Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms

'Add-in Express Add-in Module
<GuidAttribute("A88D3E2F-D1CC-464E-BE24-1F57ED49719E"), ProgIdAttribute("ADX_OL_Attachment_Size_VB.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule

    Private WithEvents AdxCommandBarButton1 As AddinExpress.MSO.ADXCommandBarButton
    Private WithEvents ExplorerCommandBar As AddinExpress.MSO.ADXOlExplorerCommandBar
#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer

    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.ExplorerCommandBar = New AddinExpress.MSO.ADXOlExplorerCommandBar(Me.components)
        Me.AdxCommandBarButton1 = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        '
        'ExplorerCommandBar
        '
        Me.ExplorerCommandBar.CommandBarName = "ADX_OL_Attachment_Size_VB"
        Me.ExplorerCommandBar.CommandBarTag = "3150c7a4-3002-48de-88d4-ee67a0fbdae6"
        Me.ExplorerCommandBar.Controls.Add(Me.AdxCommandBarButton1)
        Me.ExplorerCommandBar.Temporary = True
        Me.ExplorerCommandBar.UpdateCounter = 9
        '
        'AdxCommandBarButton1
        '
        Me.AdxCommandBarButton1.Caption = "Get attachment sizes"
        Me.AdxCommandBarButton1.ControlTag = "becb552a-2ee6-4b2e-8f34-07003a0f53fb"
        Me.AdxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxCommandBarButton1.Temporary = True
        Me.AdxCommandBarButton1.UpdateCounter = 13
        '
        'AddinModule
        '
        Me.AddinName = "ADX_OL_Attachment_Size_VB"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook

    End Sub

#End Region

#Region " Add-in Express automatic code "

    'Required by Add-in Express - do not modify
    'the methods within this region

    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function

    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub

    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub

    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub

#End Region

    Public Sub New()
        MyBase.New()
        InitializeComponent()
    End Sub

    Public ReadOnly Property OutlookApp() As Outlook._Application
        Get
            Return CType(HostApplication, Outlook._Application)
        End Get
    End Property

    Private Sub AdxCommandBarButton1_Click(ByVal sender As System.Object) Handles AdxCommandBarButton1.Click
        Dim explorer As Outlook._Explorer = OutlookApp.ActiveExplorer()
        If explorer IsNot Nothing Then
            Try
                Dim selection As Outlook.Selection = explorer.Selection
                If selection IsNot Nothing Then
                    Try
                        If (selection.Count > 0) Then
                            Dim mail As Outlook._MailItem = TryCast(selection.Item(1), Outlook._MailItem)
                            If mail IsNot Nothing Then
                                Try
                                    DoGetAttachmentSize(mail)
                                Finally
                                    Marshal.ReleaseComObject(mail)
                                End Try
                            End If
                        End If
                    Finally
                        Marshal.ReleaseComObject(selection)
                    End Try
                End If
            Finally
                Marshal.ReleaseComObject(explorer)
            End Try
        End If
    End Sub

    Private Sub DoGetAttachmentSize(ByRef mail As Outlook._MailItem)
        Dim attachments As Outlook.Attachments = mail.Attachments
        If attachments IsNot Nothing Then
            Try
                If attachments.Count > 0 Then
                    Dim Output As String = String.Empty
                    For i As Integer = 1 To attachments.Count
                        Dim attach As Outlook.Attachment = attachments.Item(i)
                        If attach IsNot Nothing Then
                            Try
                                Dim size As Long = GetMAPIProp( _
                                    attach.MAPIOBJECT, _
                                    MAPI.PR_ATTACH_SIZE)
                                Output += "#" + i.ToString() + _
                                 ": " + attach.FileName + _
                                 " " + size.ToString() + _
                                 Environment.NewLine
                            Finally
                                Marshal.ReleaseComObject(attach)
                            End Try
                        End If
                    Next i
                    If Output <> String.Empty Then MessageBox.Show(Output)
                End If
            Finally
                Marshal.ReleaseComObject(attachments)
            End Try
        End If
    End Sub

    Private Function GetMAPIProp( _
        ByVal oMAPIObject As Object, _
        ByVal uiPropertyTag As UInteger) As Long

        If (oMAPIObject Is Nothing) Then Return 0

        Dim result As String = 0
        Dim pPropValue As IntPtr = IntPtr.Zero
        Dim IUnk As IntPtr = IntPtr.Zero
        Dim IProperty As IntPtr = IntPtr.Zero
        Try
            MAPI.MAPIInitialize(IntPtr.Zero)
            IUnk = Marshal.GetIUnknownForObject(oMAPIObject)
            Dim guidMAPIProp As Guid = New Guid(MAPI.IID_IMAPIProp)
            Dim res = Marshal.QueryInterface(IUnk, guidMAPIProp, IProperty)
            If (res <> MAPI.S_OK) Then
                Dim guidMAPIAttach As Guid = New Guid(MAPI.IID_IAttachment)
                Marshal.QueryInterface(IUnk, guidMAPIAttach, IProperty)
                If (res <> MAPI.S_OK) Then Return 0
            End If
            Try
                MAPI.HrGetOneProp(IProperty, uiPropertyTag, pPropValue)
                If (pPropValue = IntPtr.Zero) Then Return 0
                Dim propValue As SPropValue
                propValue = _
                    Marshal.PtrToStructure(pPropValue, propValue.GetType())
                result = propValue.Value And UInt32.MaxValue
            Catch ex As System.Exception
                Throw ex
            End Try
        Finally
            If (pPropValue <> IntPtr.Zero) Then
                MAPI.MAPIFreeBuffer(pPropValue)
            End If
            If (IProperty <> IntPtr.Zero) Then
                Marshal.Release(IProperty)
            End If
            If (IUnk <> IntPtr.Zero) Then
                Marshal.Release(IUnk)
            End If
        End Try
        Return result
    End Function

#Region "Extended MAPI routines"

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SPropValue
        Public ulPropTag As UInteger
        Public dwAlignPad As UInteger
        Public Value As Long
    End Structure

    Friend Class MAPI
        Public Shared ReadOnly S_OK As UInteger = 0

        Public Shared ReadOnly PT_LONG As UInteger = 3

        Public Shared ReadOnly PR_ATTACH_SIZE As UInteger = (PT_LONG Or (&HE20 << 16))

        Public Shared ReadOnly IID_IMAPIProp As String = "00020303-0000-0000-C000-000000000046"
        Public Shared ReadOnly IID_IAttachment As String = "00020308-0000-0000-C000-000000000046"

        <DllImport("MAPI32.DLL", CharSet:=CharSet.Ansi, EntryPoint:="HrGetOneProp@12")> _
        Public Shared Function HrGetOneProp(ByVal pmp As IntPtr, ByVal ulPropTag As Integer, ByRef ppProp As IntPtr) As Integer
        End Function

        <DllImport("MAPI32.DLL", CharSet:=CharSet.Ansi, EntryPoint:="MAPIFreeBuffer@4")> _
        Public Shared Sub MAPIFreeBuffer(ByVal lpBuffer As IntPtr)
        End Sub

        <DllImport("MAPI32.DLL", CharSet:=CharSet.Ansi, EntryPoint:="MAPIInitialize@4")> _
        Public Shared Function MAPIInitialize(ByVal lpMapiInit As IntPtr) As Integer
        End Function
    End Class

#End Region

End Class

